diff a/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64byte.java b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64byte.java
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.util;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class StatesQ64byte extends SizeBase {
+
+    public static class ObjWrapper {
+        public Object f;
+
+        public ObjWrapper(Object f) {
+            this.f = f;
+        }
+    }
+
+    public static class ObjState extends SizeState {
+        public ObjWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ObjWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ObjWrapper(new Q64byte(i));
+            }
+        }
+    }
+
+    public static class IntWrapper {
+        public Int64 f;
+
+        public IntWrapper(Int64 f) {
+            this.f = f;
+        }
+    }
+
+    public static class IntState extends SizeState {
+        public IntWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Q64byte(i));
+            }
+        }
+    }
+
+
+    public static class RefWrapper {
+        public Q64byte f;
+
+        public RefWrapper(Q64byte f) {
+            this.f = f;
+        }
+    }
+
+    public static class RefState extends SizeState {
+        public RefWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new RefWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new RefWrapper(new Q64byte(i));
+            }
+        }
+    }
+
+
+    public static class ValWrapper {
+        public Q64byte f;
+
+        public ValWrapper(Q64byte f) {
+            this.f = f;
+        }
+    }
+
+    public static class ValState extends SizeState {
+        public ValWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ValWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ValWrapper(new Q64byte(i));
+            }
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64int.java b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64int.java
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.util;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64int;
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class StatesQ64int extends SizeBase {
+
+    public static class ObjWrapper {
+        public Object f;
+
+        public ObjWrapper(Object f) {
+            this.f = f;
+        }
+    }
+
+    public static class ObjState extends SizeState {
+        public ObjWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ObjWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ObjWrapper(new Q64int(i));
+            }
+        }
+    }
+
+    public static class IntWrapper {
+        public Int64 f;
+
+        public IntWrapper(Int64 f) {
+            this.f = f;
+        }
+    }
+
+    public static class IntState extends SizeState {
+        public IntWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Q64int(i));
+            }
+        }
+    }
+
+
+    public static class RefWrapper {
+        public Q64int f;
+
+        public RefWrapper(Q64int f) {
+            this.f = f;
+        }
+    }
+
+    public static class RefState extends SizeState {
+        public RefWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new RefWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new RefWrapper(new Q64int(i));
+            }
+        }
+    }
+
+
+    public static class ValWrapper {
+        public Q64int f;
+
+        public ValWrapper(Q64int f) {
+            this.f = f;
+        }
+    }
+
+    public static class ValState extends SizeState {
+        public ValWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ValWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ValWrapper(new Q64int(i));
+            }
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64long.java b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ64long.java
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.util;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class StatesQ64long extends SizeBase {
+
+    public static class ObjWrapper {
+        public Object f;
+
+        public ObjWrapper(Object f) {
+            this.f = f;
+        }
+    }
+
+    public static class ObjState extends SizeState {
+        public ObjWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ObjWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ObjWrapper(new Q64long(i));
+            }
+        }
+    }
+
+    public static class IntWrapper {
+        public Int64 f;
+
+        public IntWrapper(Int64 f) {
+            this.f = f;
+        }
+    }
+
+    public static class IntState extends SizeState {
+        public IntWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Q64long(i));
+            }
+        }
+    }
+
+
+    public static class RefWrapper {
+        public Q64long f;
+
+        public RefWrapper(Q64long f) {
+            this.f = f;
+        }
+    }
+
+    public static class RefState extends SizeState {
+        public RefWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new RefWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new RefWrapper(new Q64long(i));
+            }
+        }
+    }
+
+
+    public static class ValWrapper {
+        public Q64long f;
+
+        public ValWrapper(Q64long f) {
+            this.f = f;
+        }
+    }
+
+    public static class ValState extends SizeState {
+        public ValWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ValWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ValWrapper(new Q64long(i));
+            }
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/intrinsics/IsFlatArray.java b/test/micro/org/openjdk/bench/valhalla/intrinsics/IsFlatArray.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/intrinsics/IsFlatArray.java
@@ -0,0 +1,95 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package org.openjdk.bench.valhalla.intrinsics;
+
+import org.openjdk.jmh.annotations.*;
+
+import java.lang.invoke.MethodHandles;
+import java.lang.invoke.VarHandle;
+import java.util.concurrent.TimeUnit;
+import jdk.internal.misc.Unsafe;
+
+@BenchmarkMode(Mode.Throughput)
+@OutputTimeUnit(TimeUnit.MICROSECONDS)
+@Fork(value = 1,
+      jvmArgsAppend = {"--add-opens", "java.base/jdk.internal.misc=ALL-UNNAMED",
+                       "--enable-preview"})
+@Warmup(iterations = 3, time = 1)
+@Measurement(iterations = 5, time = 1)
+public class IsFlatArray {
+
+    private static final Unsafe U = Unsafe.getUnsafe();
+    private static final VarHandle objectArrayVarHandle =
+        MethodHandles.arrayElementVarHandle(Object[].class);
+
+    @State(Scope.Benchmark)
+    public static class ClassState {
+        public Class flatArrayClass = Point[].class;
+        public Class nonFlatArrayClass = String[].class;
+
+        public Object[] objectArray = new Object[10];
+        public Object objectElement = new Object();
+        public int arrayIndex = 0;
+    }
+
+    @Benchmark
+    public boolean testKnownFlatClass() {
+        return U.isFlatArray(Point[].class);
+    }
+
+    @Benchmark
+    public boolean testKnownNonFlatClass() {
+        return U.isFlatArray(String[].class);
+    }
+
+    @Benchmark
+    public boolean testUnknownFlatClass(ClassState state) {
+        return U.isFlatArray(state.flatArrayClass);
+    }
+
+    @Benchmark
+    public boolean testUnknownNonFlatClass(ClassState state) {
+        return U.isFlatArray(state.nonFlatArrayClass);
+    }
+
+    @Benchmark
+    public void setArrayElement(ClassState state) {
+        objectArrayVarHandle.set(state.objectArray, state.arrayIndex, state.objectElement);
+    }
+
+    @Benchmark
+    public VarHandle makeArrayVarHandle() {
+        return MethodHandles.arrayElementVarHandle(Object[].class);
+    }
+
+}
+
+value class Point {
+    int x;
+    int y;
+    public Point(int x, int y) {
+        this.x = x;
+        this.y = y;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/invoke/IdentityArray.java b/test/micro/org/openjdk/bench/valhalla/invoke/IdentityArray.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/invoke/IdentityArray.java
@@ -0,0 +1,306 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.invoke;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@Warmup(iterations = 5, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class IdentityArray {
+
+    public static final int SIZE = 128;
+
+    public interface MyInterface {
+        public int my_method();
+    }
+
+    public static class Ref1 implements MyInterface {
+        public final int f0;
+        public Ref1(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static class Ref2 implements MyInterface {
+        public final int f0;
+        public Ref2(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static class Ref3 implements MyInterface {
+        public final int f0;
+        public Ref3(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    @State(Scope.Thread)
+    public static abstract class IntState {
+        public MyInterface[] arr;
+    }
+
+    @State(Scope.Thread)
+    public static abstract class Ref1State {
+        public Ref1[] arr;
+    }
+
+    public static class Ref1_as_Ref extends Ref1State {
+        @Setup
+        public void setup() {
+            arr = new Ref1[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref1(i);
+            }
+        }
+    }
+
+    public static class Ref1_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Ref1[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref1(i);
+            }
+        }
+    }
+
+    public static class Int1_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new MyInterface[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref1(i);
+            }
+        }
+    }
+
+    public static class Ref2_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Ref2[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref2(i);
+            }
+        }
+    }
+
+    public static class Int2_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new MyInterface[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref2(i);
+            }
+        }
+    }
+
+    public static class Ref3_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Ref3[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref3(i);
+            }
+        }
+    }
+
+    public static class Int3_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new MyInterface[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref3(i);
+            }
+        }
+    }
+
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int reduceInt(MyInterface[] arr) {
+        int r = 0;
+        for (int i = 0; i < arr.length; i++) {
+            r += arr[i].my_method();
+        }
+        return r;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int reduceRef(Ref1[] arr) {
+        int r = 0;
+        for (int i = 0; i < arr.length; i++) {
+            r += arr[i].my_method();
+        }
+        return r;
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Ref_r(Ref1_as_Ref st0, Ref1_as_Ref st1, Ref1_as_Ref st2, Ref1_as_Ref st3, Ref1_as_Ref st4, Ref1_as_Ref st5) {
+        return reduceRef(st0.arr) +
+               reduceRef(st1.arr) +
+               reduceRef(st2.arr) +
+               reduceRef(st3.arr) +
+               reduceRef(st4.arr) +
+               reduceRef(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Int_r(Ref1_as_Int st0, Ref1_as_Int st1, Ref1_as_Int st2, Ref1_as_Int st3, Ref1_as_Int st4, Ref1_as_Int st5) {
+        return reduceInt(st0.arr) +
+               reduceInt(st1.arr) +
+               reduceInt(st2.arr) +
+               reduceInt(st3.arr) +
+               reduceInt(st4.arr) +
+               reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Int_i(Int1_as_Int st0, Int1_as_Int st1, Int1_as_Int st2, Int1_as_Int st3, Int1_as_Int st4, Int1_as_Int st5) {
+        return reduceInt(st0.arr) +
+               reduceInt(st1.arr) +
+               reduceInt(st2.arr) +
+               reduceInt(st3.arr) +
+               reduceInt(st4.arr) +
+               reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Int_ri(Ref1_as_Int st0, Int1_as_Int st1, Ref1_as_Int st2, Int1_as_Int st3, Ref1_as_Int st4, Int1_as_Int st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target2_Int_r(Ref1_as_Int st0, Ref2_as_Int st1, Ref1_as_Int st2, Ref2_as_Int st3, Ref1_as_Int st4, Ref2_as_Int st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target2_Int_i(Int1_as_Int st0, Int2_as_Int st1, Int1_as_Int st2, Int2_as_Int st3, Int1_as_Int st4, Int2_as_Int st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target2_Int_ri(Ref1_as_Int st0, Int1_as_Int st1, Ref2_as_Int st2, Int1_as_Int st3, Ref1_as_Int st4, Int2_as_Int st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target3_Int_r(Ref1_as_Int st0, Ref2_as_Int st1, Ref3_as_Int st2, Ref1_as_Int st3, Ref2_as_Int st4, Ref3_as_Int st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target3_Int_i(Int1_as_Int st0, Int2_as_Int st1, Int3_as_Int st2, Int1_as_Int st3, Int2_as_Int st4, Int3_as_Int st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target3_Int_ri(Ref1_as_Int st0, Int2_as_Int st1, Ref3_as_Int st2, Int1_as_Int st3, Ref2_as_Int st4, Int3_as_Int st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/invoke/IdentityField.java b/test/micro/org/openjdk/bench/valhalla/invoke/IdentityField.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/invoke/IdentityField.java
@@ -0,0 +1,218 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.invoke;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@Warmup(iterations = 5, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class IdentityField {
+
+    public static final int SIZE = 128;
+
+    public interface MyInterface {
+        public int my_method();
+    }
+
+    public static class Ref1 implements MyInterface {
+        public final int f0;
+        public Ref1(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static class Ref2 implements MyInterface {
+        public final int f0;
+        public Ref2(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static class Ref3 implements MyInterface {
+        public final int f0;
+        public Ref3(int f0) {
+            this.f0 = f0;
+        }
+        @Override
+        public int my_method() {
+            return f0;
+        }
+    }
+
+    public static class Ref1Wrapper {
+        public Ref1 f;
+
+        public Ref1Wrapper(Ref1 f) {
+            this.f = f;
+        }
+    }
+
+    public static class IntWrapper {
+        public MyInterface f;
+
+        public IntWrapper(MyInterface f) {
+            this.f = f;
+        }
+    }
+
+    @State(Scope.Thread)
+    public static class Ref1State {
+        public Ref1Wrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new Ref1Wrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Ref1Wrapper(new Ref1(i));
+            }
+        }
+    }
+
+    @State(Scope.Thread)
+    public static class IntStateBase {
+        public IntWrapper[] arr;
+    }
+
+    public static class Int1State extends IntStateBase {
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Ref1(i));
+            }
+        }
+    }
+
+    public static class Int2State extends IntStateBase {
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Ref2(i));
+            }
+        }
+    }
+
+    public static class Int3State extends IntStateBase {
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[SIZE];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Ref3(i));
+            }
+        }
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int reduceRef(Ref1Wrapper[] arr) {
+        int r = 0;
+        for (int i = 0; i < arr.length; i++) {
+            r += arr[i].f.my_method();
+        }
+        return r;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int reduceInt(IntWrapper[] arr) {
+        int r = 0;
+        for (int i = 0; i < arr.length; i++) {
+            r += arr[i].f.my_method();
+        }
+        return r;
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Ref(Ref1State st0, Ref1State st1, Ref1State st2, Ref1State st3, Ref1State st4, Ref1State st5) {
+        return reduceRef(st0.arr) +
+                reduceRef(st1.arr) +
+                reduceRef(st2.arr) +
+                reduceRef(st3.arr) +
+                reduceRef(st4.arr) +
+                reduceRef(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target1_Int(Int1State st0, Int1State st1, Int1State st2, Int1State st3, Int1State st4, Int1State st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target2_Int(Int1State st0, Int2State st1, Int1State st2, Int2State st3, Int1State st4, Int2State st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE * 6)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int target3_Int(Int1State st0, Int2State st1, Int3State st2, Int1State st3, Int2State st4, Int3State st5) {
+        return reduceInt(st0.arr) +
+                reduceInt(st1.arr) +
+                reduceInt(st2.arr) +
+                reduceInt(st3.arr) +
+                reduceInt(st4.arr) +
+                reduceInt(st5.arr);
+    }
+
+
+
+}
